"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLastFieldParents = exports.getFieldParts = exports.getLastField = exports.getField = exports.getColumn = void 0;
var defaultOptions_1 = __importDefault(require("../defaultOptions"));
var getColumn = function (columns, columnKey) { return columns.find(function (c) { return c.key === columnKey; }); };
exports.getColumn = getColumn;
var getField = function (column) {
    return column.field || column.key;
};
exports.getField = getField;
var getLastField = function (field) {
    if (defaultOptions_1.default.fieldDelimiter) {
        return field.split(defaultOptions_1.default.fieldDelimiter).pop();
    }
    return field;
};
exports.getLastField = getLastField;
var getFieldParts = function (field) {
    return defaultOptions_1.default.fieldDelimiter ? field.split(defaultOptions_1.default.fieldDelimiter) : [field];
};
exports.getFieldParts = getFieldParts;
var getLastFieldParents = function (field) {
    if (defaultOptions_1.default.fieldDelimiter) {
        var fieldParents = field.split(defaultOptions_1.default.fieldDelimiter);
        fieldParents.pop();
        return fieldParents;
    }
    return [];
};
exports.getLastFieldParents = getLastFieldParents;
